Index: /trunk/doc/CHANGES.OS2
===================================================================
--- /trunk/doc/CHANGES.OS2	(revision 240)
+++ /trunk/doc/CHANGES.OS2	(revision 241)
@@ -4,4 +4,31 @@
 
 CHANGES
+
+
+1.6.0 Build 19 Beta 2 (2011-01-12)
+
+  - Added a predefined font configuration file to use the Liberation font family
+    as Java system fonts (see README.OS2 for details).
+
+  - Added the jawt.lib library to the SDK package.
+
+  - Added some missing GUI and audio classes to rt.jar.
+
+  - Fixed: Java could not find a .jar file in the current directory when
+    starting it with 'java -jar filename.jar'.
+
+  - Fixed: Non-ASCII characters in the title bar of any Java window would be
+    drawn using wrong glyphs.
+
+  - Fixed: Java could incorrectly detect the default object heap size on some
+    systems for some specific VIRTUALADDRESS values and abort at startup with a
+    "Could not reserve enough space for object heap" error message.
+
+  - Fixed: java.io.File.mkdirs() wouild always fail which would in particular
+    abort the installation process of some applications such as jEdit, iTrain
+    (this bug was actually fixed in Odin).
+
+  - Fixed: An attempt to use Drag & Drop in any Java application would cause
+    a Java exception and program termination.
 
 
Index: /trunk/doc/README.OS2
===================================================================
--- /trunk/doc/README.OS2	(revision 240)
+++ /trunk/doc/README.OS2	(revision 241)
@@ -1,5 +1,5 @@
 OpenJDK 6 Alpha for OS/2 and eCS
 
-Version 1.6.0 Build 19 Beta (2010-12-30)
+Version 1.6.0 Build 19 Beta 2 (2011-01-12)
 
 This is a beta build intended for testing purposes.
@@ -28,7 +28,7 @@
   - A OS/2 Warp 4 Fixpack 16+, OS/2 Warp 4.5 or eComStation operating system.
 
-  - Odin32 library version 0.6.21541 (2010-12-30) or above:
-
-    ftp://ftp.netlabs.org/pub/odin/odin32bin-20101230-release.wpi
+  - Odin32 library version 0.6.21558 (2011-01-12) or above:
+
+    ftp://ftp.netlabs.org/pub/odin/odin32bin-20110112-release.wpi
 
 
@@ -46,6 +46,7 @@
 
   Also make sure there are no traces of other Java installations in the
-  environment because this is known to make problems (this in particular means
-  that the CLASSPATH environment variable should not be set).
+  environment because this is known to make problems (in particular, this means
+  that the CLASSPATH/JAVA_HOME/SWING_HOME environment variables should not be
+  set).
 
   Alternatively, you may add this subdirectory to PATH and LIBPATH statements
@@ -81,11 +82,12 @@
      normally (for example, using the OS/2 Font Palette object).
 
-  3. Go to the directory "<OpenJDK>\bin\jre\lib" (where <OpenJDK> is where you
-     installed the OpenJDK package) and copy the file
-     "fontconfig.liberation.bfc" to "fontconfig.bfc". It is safe to overwrite
-     the target file.
+  3. Go to the directory "<SDK>\bin\jre\lib" (where <SDK> is where you installed
+     SDK package) or "<JRE>\lib" (where <JRE is where you installed the JRE
+     package) and copy the file "fontconfig.liberation.bfc" to "fontconfig.bfc".
+     It is safe to overwrite the target file.
 
   In order to return back to the default fonts, go to "<OpenJDK>\bin\jre\lib"
-  again and copy the file "fontconfig.default.bfc" to "fontconfig.bfc".
+  (or to "<JRE>\lib") again and copy the file "fontconfig.default.bfc" to
+  "fontconfig.bfc".
 
   Note that you need to restart all Java applications to let them pick up the
@@ -211,9 +213,11 @@
      Warp4 kernel instead.
 
-  2. The separate JRE package of OpenJDK is not currently available. You may
-     still extract JRE from the SDK package (it is located in the \jre
-     subdirectory of the SDK distribution archive).
-
-  3. Some rarely used Java system classes may be still missing in this release.
+  2. The JPDA (Java Platform Debugger Architecture) component is missing.
+
+  3. The com.sun.tools.attach package (API to attach to a Java virtual machine)
+     is missing.
+
+  4. Some other rarely used Java system classes may also be missing in this
+     release.
 
   See the project roadmap for more information on the current progress and